

package SFC::Distance;

use strict;
use warnings qw{ all };

use POSIX;

our (@ISA, @EXPORT_OK);
BEGIN {
    require Exporter;
    @ISA = qw{Exporter};
    @EXPORT_OK = qw{
            distance
            travel_time
        };
}


sub distance {
    my ($planet1, $planet2) = @_;

    my $diff;

    if ($diff = $planet1->galaxy - $planet2->galaxy) {
        return 20000 * abs($diff);
    }
    elsif ($diff = $planet1->system - $planet2->system) {
        return 2700 + 95 * abs($diff);
    }
    elsif ($diff = $planet1->planet - $planet2->planet) {
        return 1000 + 5 * abs($diff);
    }
    else {
        return 5;
    }

    # notreached
}


sub travel_time {       # in seconds
    my ($distance, $speed, $frac) = @_;

    return 10 + ceil(3500 * sqrt(10 * $distance / $speed) / $frac);
}



1;
