
package SFC::FSArray;

use strict;
use warnings qw{ all };

our (@ISA, @EXPORT_OK);
BEGIN {
    require Exporter;
    @ISA = qw{Exporter};
    @EXPORT_OK = qw{
            serialize
            deserialize
        };
}

use JSON -convert_blessed_universally;
use Carp;


sub serialize {
    to_json($_[0], { convert_blessed => 1 });
}

sub deserialize {
    my $data = from_json($_[0]);  # croaks if not valid JSON

    ref($data) eq 'ARRAY' or croak $_[0] . " is not an array";

    for my $fs (@$data) {
        ref($fs) eq 'HASH'
            or croak "non-hash element at level 1 (FleetSummary)";
        while (my ($k, $v) = each %$fs) {
            if ($k =~ /^[A-Z][a-z][a-z]$/) {
                next;
            }
            if ($k eq 'location') {
                ref($v) eq 'HASH'
                    or croak "non-hash element for location";
                bless $v, 'SFC::Planet';
                next;
            }
        }
        bless $fs, 'SFC::FleetSummary';
    }

    return $data;
}

