
package SFC::Memoize;

use strict;
use warnings qw{ all };

use Carp;

our (@ISA, @EXPORT_OK);
BEGIN {
    require Exporter;
    @ISA = qw{Exporter};
    @EXPORT_OK = qw{
            memoize
        };
}


sub memoize {
    my $f = shift;

    my %cache = ( @_ );
    sub {
        my ($arg, $cachedp) = @_;
        if (!defined $arg) {
            confess;
        }
        if ($cachedp) {
            return exists $cache{$arg};
        }
        if (! exists $cache{$arg}) {
            $cache{$arg} = $f->($arg);
        }
        return $cache{$arg};
    }
}

1;
