
package SFC::Planet;

use strict;
use warnings qw{ all };

use POSIX;

sub new {
    my $this = shift;
    my $class = ref($this) || $this;
    my $self = ref($this) ? { %$this } : {
            # defaults
        };
    bless $self, $class;
    
    my ($galaxy, $system, $planet, $type) = @_;
    $type = '' unless $type;
    $self->{galaxy} = $galaxy;
    $self->{system} = $system;
    $self->{planet} = $planet;
    $self->{type} = $type;

    return $self;
}


sub distance {
    my $self = shift;
    my ($other) = @_;

    my $diff;

    if ($diff = $self->galaxy - $other->galaxy) {
        return 20000 * abs($diff);
    }
    elsif ($diff = $self->system - $other->system) {
        return 2700 + 95 * abs($diff);
    }
    elsif ($diff = $self->planet - $other->planet) {
        return 1000 + 5 * abs($diff);
    }
    elsif ($self->type eq 'e' || $other->type eq 'e') {
        return 1005;
    }
    else {
        return 5;
    }

    # notreached
}


sub galaxy { $_[0]->{galaxy} }
sub system { $_[0]->{system} }
sub planet { $_[0]->{planet} }
sub type { $_[0]->{type} }

1;
