
package SFC::SimpleSim;

use strict;
use warnings qw{ all };

our (@ISA, @EXPORT_OK);
BEGIN {
    require Exporter;
    @ISA = qw{Exporter};
    @EXPORT_OK = qw{simulate};
}

sub simulate {
    my ($attacker, $defender, $callback) = @_;

    my $round;
    for ($round = 0; $round < 6; ++$round) {
        last if $attacker->destroyed();
        last if $defender->destroyed();
        $attacker->reset_shields();
        $defender->reset_shields();
        $attacker->attack($defender);
        $defender->attack($attacker);
        $attacker->explosion();
        $defender->explosion();
        $callback->($round, $attacker, $defender);
    }

    return $round;
}

1;
