
package SFC::Simulate;

use strict;
use warnings qw{ all };

use SFC::Fleet;

our (@ISA, @EXPORT_OK);
BEGIN {
    require Exporter;
    @ISA = qw{Exporter};
    @EXPORT_OK = qw{simulate};
}

sub simulate {
    my ($attackers, $defenders, $callback) = @_;

    my $attacker = SFC::Fleet->new({ is_attacker => 1 }, @$attackers);
    my $defender = SFC::Fleet->new({ is_attacker => 0 }, @$defenders);

    my $round;
    for ($round = 0; $round < 6; ++$round) {
        last if $attacker->destroyed();
        last if $defender->destroyed();
        $attacker->reset_shields();
        $defender->reset_shields();
        $attacker->reset_detonations();
        $attacker->nostat_attack($defender);
        $defender->nostat_attack($attacker);
        $attacker->explosion();
        $defender->explosion();
        if (defined $callback) {
            $callback->($round, $attacker, $defender);
        }
    }

    my $asi = $attacker->destroyed() ?
            ($defender->destroyed() ? 0 : -7 + $round) :
            ($defender->destroyed() ? 7 - $round : 0);

    return $asi, $attacker->results(), $defender->results();
}

1;
