#!/usr/bin/perl

use SFC::Ship;
use SFC::ShipStats qw{ all_units fuel_consumption }; # is_ship

$arg = shift || 1000;

my ($ore, $cry, $gen) = (0, 0, 0);

for my $t ( all_units() ) {
    next unless fuel_consumption($t) > 0;
    my $s = SFC::Ship->new($t);
    next unless $s->is_ship;

    # my $c = 0.6 * $s->ore_cost + $s->crystal_cost + 1.5 * $s->hydrogen_cost;
    # my $c = 0.5 * $s->ore_cost + $s->crystal_cost + 0 * $s->hydrogen_cost;
    # my $c = 0.25 * $s->ore_cost + $s->crystal_cost + 0 * $s->hydrogen_cost;
    # my $c = 0.3 * $s->ore_cost + $s->crystal_cost - 1.0 * $s->hydrogen_cost;
    # my $c = 0.75 * $s->ore_cost + $s->crystal_cost + 0.5 * $s->hydrogen_cost;
    # my $c = 0.75 * $s->ore_cost + $s->crystal_cost - 0.5 * $s->hydrogen_cost;
    # my $c = 0.6 * $s->ore_cost + $s->crystal_cost - 3.0 * $s->hydrogen_cost;
  # my $c = 0 * $s->ore_cost + $s->crystal_cost - 1.0 * $s->hydrogen_cost;
    # my $c = $s->crystal_cost;

    my $c = $s->ore_cost + $s->crystal_cost / .6 + $s->hydrogen_cost * 2.5;

    next unless $c > 0;

    my $n = $arg / $c;
    printf "%3s %8.0f %12.5f\n", $t, $c, $n;
    $ore += $n * $s->ore_cost;
    $cry += $n * $s->crystal_cost;
    $gen += $n * $s->hydrogen_cost;
}

print "$ore ore, $cry crystal, $gen hydrogen\n";
print $cry / $ore, " : 1 : ", $cry / $gen, "\n";
print $ore / $cry, " : 1 : ", $gen / $cry, "\n";

