#!/usr/bin/perl

use utf8;
# use locale;
binmode STDOUT, ':utf8';
binmode STDIN,  ':utf8';

use strict;
use warnings qw{ all };

# use JSON;
# use Data::Dumper;
# $Data::Dumper::Terse = 1;
# $Data::Dumper::Indent = 0;


use SFC::FleetSummary;
use SFC::Simulate qw{ simulate };
use SFC::FSArray qw{ serialize deserialize };



my $attackers;
my $defenders;


#
# Main loop
#

$| = 1;

while (<>) {
    next if /^$/;
    if (/^Attackers: (.*)$/) {
        $attackers = deserialize($1);
        next;
    }
    if (/^Defenders: (.*)$/) {
        $defenders = deserialize($1);
        next;
    }
    if (/^run$/) {
        my ($rounds, $att_res, $def_res) = simulate($attackers, $defenders);

        print 'Success-Index: ', $rounds, "\n"; 
        print 'Attacker-Results: ', serialize($att_res), "\n";
        print 'Defender-Results: ', serialize($def_res), "\n";
        print "done\n";
    }
}
