#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "simserv.h"

int
main()
{
    Fleet att, def;
    int asi;
    char buf[BUF_SIZE];
    char *keyword, *data;

    fleet_init(&att);
    fleet_init(&def);

    init_json();

    while (fgets(buf, BUF_SIZE, stdin)) {

        keyword = strtok(buf, " :\n");
        if (keyword == NULL) continue;

        if (strcmp(keyword, "run") == 0) {
            asi = simulate(&att, &def);
            printf("Success-Index: %d\n", asi);
            printf("Attacker-Results: %s\n", json_from_fleet(&att, buf));
            printf("Defender-Results: %s\n", json_from_fleet(&def, buf));
            printf("done\n");
            fflush(stdout);
            continue;
        }
        
        data = strtok(NULL, "\n");

        if (strcmp(keyword, "Seed") == 0) {
            fprintf(stderr, "setting seed\n");
            srandom(strtol(data, NULL, 0));
            continue;
        }

        if (strcmp(keyword, "Attackers") == 0) {
            fprintf(stderr, "reading attackers\n");
            fleet_from_json(&att, data);
            continue;
        }

        if (strcmp(keyword, "Defenders") == 0) {
            fprintf(stderr, "reading defenders\n");
            fleet_from_json(&def, data);
            continue;
        }

    }

    return 0;
}
