enum ship_type {
    MIS, LAS, PUL, PAR, DEC, GAU, LAR, PLA,
    HRM, HEL, ART, ATL, APO, CHA, HRC, DIO,
    POS, GAI, ATH, ARE, HAD, PRO, ZEU, HEP,
    STZ
};

typedef struct ship {
    int type;
    short fleet_id;
    int weapon;
    int max_shield;
    int max_hull;
    int shield;
    int hull;
} Ship;

typedef struct fleet {
    int count;
    Ship **active;
    int start;
    Ship *data;
    Ship **alt;	/* scratch */
    int fleets;
    void *json;
    int (*lost)[STZ];
} Fleet;

int  simulate(Fleet *attackers, Fleet *defenders);
void fleet_alloc(Fleet *f, int fleets, int ships);
void fleet_free(Fleet *f);
void fleet_init(Fleet *f);

void init_json(void);
void fleet_from_json(Fleet *f, char *json);
char *json_from_fleet(Fleet *f, char *buf);

#define BUF_SIZE 4096
