
function Ship() {



}
    my ($type, $fs, $id, $is_attacker) = @_;
    if (defined $type) {
        $self->[$s_type] = $type;
    }
    if (defined $fs) {
        $self->[$s_weapon] = attack_strength($type, $fs);
        $self->[$s_max_shield] = shield_strength($type, $fs);
        $self->[$s_max_hull] = $self->[$s_hull] = hull($type, $fs);
        # $self->[$s_round_def] = $self->[$s_hull] + $self->[$s_max_shield];
    }
    if (defined $id) {
        $self->[$s_fleet_id] = $id;
    }
    if (defined $is_attacker) {
        if ($type eq 'Emp') {
            if ($is_attacker) {
                $self->[$s_hull] = 0;
            }
            else {
                $self->[$s_weapon] = 0;
            }
        }
    }

    return $self;
}

use SFC::ShipStats qw{
        full_name
        attack_strength
        shield_strength
        hull
        rapidfire_value
    };

# use SFC::Rapidfire qw{ rapidfire_value };

my ($s_type, $s_weapon, $s_max_shield, $s_max_hull, $s_hull, $s_shield,
        $s_fleet_id, $s_round_def)
    = (0, 1, 2, 3, 4, 5, 6, 7);

sub attack {
    my $self = shift;
    my ($opponent, $fleet) = @_;

    my $range = $opponent->ships();
    return if $#$range < 0;

    my $flt_res = $fleet->results($self);

    if ($self->[$s_type] eq 'Min') {
        return unless $opponent->detonations_left;
        return if rand 1 > .2;  # *approximately* (?!) 20% chance of detonation
        $self->[$s_hull] = 0;
        $opponent->detonation;
        if (rand 1 > 0.75) {    # failed 75% chance of hitting opponent
            $range = $fleet->ships();
        }

# XXX statistics should be?
    }

    my $s;
    LOOP: {
        do {
            $s = $range->[int rand @$range];

            # Ineffectiveness Rule
            if ($self->[$s_weapon] <= $s->[$s_max_shield] / 100) {
                $opponent->results($s)->ir_gain($self->[$s_weapon], $s);
                $flt_res->ir_loss($self->[$s_weapon], $self);
                last;
            }

            # theoretical effect in isolation
            my $eff = $self->[$s_weapon] < $s->[$s_round_def] ?
                $self->[$s_weapon] : $s->[$s_round_def];
            $flt_res->effect($eff, $self);

            # actual effect
            $s->[$s_shield] -= $self->[$s_weapon];
            if ($s->[$s_shield] < 0) {
                $s->[$s_hull] += $s->[$s_shield];
                $s->[$s_shield] = 0;
            }

        } while $self->rapidfire_succeeds($s);
    }

    if ($s->[$s_hull] < 0) {
        my $h = -$s->[$s_hull];
        my $w = $self->[$s_weapon];
        my $overkill = $h > $w ? $w : $h;
        $opponent->results($s)->overkill_taken($overkill, $s);
        $flt_res->overkill_given($overkill, $self);
    }
}


# same as attack(), but doesn't keep per-type statistics
sub nostat_attack {
    my $self = shift;
    my ($opponent, $fleet) = @_;

    my $range = $opponent->ships();
    return if $#$range < 0;

    if ($self->[$s_type] eq 'Min') {
        return unless $opponent->detonations_left;
        return if rand 1 > .2;  # *approximately* (?!) 20% chance of detonation
        $self->[$s_hull] = 0;
        $opponent->detonation;
        if (rand 1 > 0.75) {    # failed 75% chance of hitting opponent
            $range = $fleet->ships();
        }
    }

    my $s;
    LOOP: {
        do {
            $s = $range->[int rand @$range];

            # Ineffectiveness Rule
            if ($self->[$s_weapon] <= $s->[$s_max_shield] / 100) {
                last;
            }

            $s->[$s_shield] -= $self->[$s_weapon];
            if ($s->[$s_shield] < 0) {
                $s->[$s_hull] += $s->[$s_shield];
                $s->[$s_shield] = 0;
            }

        } while $self->rapidfire_succeeds($s);
    }
}


sub rapidfire_succeeds {
    my $self = shift;
    my ($op_ship) = @_;

    my $rfv = rapidfire_value($self->[$s_type], $op_ship->[$s_type]);

    return 0 unless $rfv;

    return rand 1 > 1 / $rfv;
}


sub explodes {
    my $self = shift;

    my $hull = $self->[$s_hull] / $self->[$s_max_hull];
    return $hull < .7 ? (rand 1 > $hull) : 0;
}


sub print_status {
    my $self = shift;
    my $n = full_name($self->[$s_type]);
    print <<EOT;
Type: $n
Shield: $self->[$s_shield] / $self->[$s_max_shield]
Hull: $self->[$s_hull] / $self->[$s_max_hull]

EOT

}



sub reset_shield {
    # my $self = shift;

    $_[0]->[$s_shield] = $_[0]->[$s_max_shield];
    # $self->[$s_round_def] = $self->[$s_hull] + $self->[$s_max_shield];
}

sub type          { $_[0]->[$s_type] }
sub id            { $_[0]->[$s_fleet_id] }
sub ore_cost      { SFC::ShipStats::ore_cost($_[0]->[$s_type]) }
sub crystal_cost  { SFC::ShipStats::crystal_cost($_[0]->[$s_type]) }
sub hydrogen_cost { SFC::ShipStats::hydrogen_cost($_[0]->[$s_type]) }
sub is_ship       { SFC::ShipStats::is_ship($_[0]->[$s_type]) }

1;
